#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Oct 26 11:37:05 2021

@author: ricardofaria

Interpolate 2d grid

"""


import numpy as np


def interpolate_2d_grid(var, mask, lon_org, lat_org, lon_final, lat_final, method='linear'):
    
    '''
    Interpolate a grid with original lat lon to a specific final lat lon.
    
    '''
    
    # import  mpl_toolkits.basemap
    # XI, YI = np.meshgrid(lon_final, lat_final)
    # new_var = mpl_toolkits.basemap.interp(var, lon_org, lat_org, XI, YI, checkbounds=False, masked=False, order=1)
    
    # new_var = np.zeros((lat_final.shape[0], lon_final.shape[0]))
    # for x in range(new_var.shape[0]):
    #     for y in range(new_var.shape[1]+1):
    #         if mask[y, x] == False:
    #             new_var[y, x] = np.interp(lat_final[y], lat_org, var[:, x])
    #             # new_var[y, x] = (np.interp(lon_final[x], lon_org, var[y, :])+new_var[y, x])/2
    
    # new_var = np.zeros((lat_final.shape[0], lon_final.shape[0]))
    # for x in range(var.shape[0]):
    #     new_var[:, x] = np.interp(lat_final, lat_org, var[:, x])
    # for y in range(new_var.shape[1]+1):
    #     new_var[y, :] = np.interp(lon_final, lon_org, new_var[y, :var.shape[0]])
    
    import scipy.interpolate
    
    X, Y = np.meshgrid(lon_org, lat_org)
    XI, YI = np.meshgrid(lon_final, lat_final)
    # interpolate only
    new_var = scipy.interpolate.griddata((X.flatten(), Y.flatten()), var.flatten(), (XI,YI), method=method)
    # interpolate masked
    new_var = scipy.interpolate.griddata((X.flatten()[~np.isnan(var.flatten())], Y.flatten()[~np.isnan(var.flatten())]), var.flatten()[~np.isnan(var.flatten())], (XI,YI), method=method)
        
    new_var = np.ma.masked_where(mask == True, new_var)
    
    return new_var